#!BuildIgnore:          post-build-checks
%define	_default_patch_fuzz	3
%define	reldate	140620_svn4217
%define	sodate %(date +%%y%%m%%d)
%define	pfringver	5.6.2
Name:		nprobe
Version:	6.16
Release:	25.13
Group:		System
Summary:	Netflow Probe
Url:		http://www.nmon.net/
License:	GPL
Source0:	%{name}_%{version}.%{reldate}_proplugins.tgz
Source1:	GeoLiteCity.dat.gz
Source2:	GeoIPASNum.dat.gz
Source3:	GeoIPASNumv6.dat.gz
Source5:	UsersGuide.pdf
%if 0%{?suse_version}
Source6:	nprobe.init.suse
%else
Source6:	nprobe.init.rh
%endif
Source7:	sysconfig.nprobe
Source8:	nDPI.tar.bz2
Source9:	PF_RING-%{pfringver}.tar.bz2
Patch1:		nprobe-%{version}-GeoIPdat-dir.patch
Patch2:		nprobe-%{version}-configure.in.patch
Patch3:		nprobe.h-prefix.patch
Patch4:		nprobe-ifindex.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

NoSource:	0

%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
BuildRequires:	gawk which
BuildRequires:	tcp_wrappers libpcap-devel
%endif
%if 0%{?fedora_version} >= 7 || 0%{?rhel_version} >= 600 || 0%{?centos_version} >= 6
BuildRequires:	tcp_wrappers-devel
%endif
%if 0%{?suse_version} > 1010
BuildRequires:	awk libpcap-devel tcpd-devel
%endif
%if 0%{?suse_version} > 0 && 0%{?suse_version} <= 1010
BuildRequires:	awk libpcap tcpd-devel
%endif
%if 0%{?suse_version}
PreReq:		%insserv_prereq %fillup_prereq
%endif

%if 0%{?suse_version}
%ifarch x86_64
BuildRequires:  libnuma-devel
%else
ExclusiveArch: x86_64
%endif
%else
BuildRequires:  numactl-devel
%endif

BuildRequires:	zeromq-devel
BuildRequires:	libhiredis-devel
BuildRequires:	libcyassl-devel
## if 0%{?suse_version} || 0%{?redhat_version} >= 600 || 0%{?rhel} >= 6 || 0%{?centos_version} >= 6
##BuildRequires:	libjson-c-devel
## endif

BuildRequires:	autoconf automake libtool gcc-c++ grep sed flex bison
BuildRequires:	pcre-devel mysql-devel libGeoIP-devel >= 1.4.5 lksctp-tools-devel python-devel openssl-devel
BuildRequires:	sqlite-devel >= 3.0
BuildRequires:	libpfring-devel
BuildRequires:	subversion

%description
Light, fast, resource-savvy NetFlow v5 and v9 probe that can be used stand-alone, with commercial products, or with ntop.

%package devel
Group:		Development/Libraries
Summary:	NProbe devel files

%description devel
NProbe development files.

%prep
%setup -n %{name}_%{version}.%{reldate}_proplugins -a 8 -b 9
%patch1
%patch2
%patch3
%patch4

cp %{S:1} .
cp %{S:2} .
cp %{S:3} .
cp %{S:5} .
cd ..
mv PF_RING-%{pfringver} PF_RING

%build
# pre build libpfring & libpcap of PF_RING
pre=`pwd`
cd ../PF_RING/userland/lib
./configure
make
cd ../libpcap
./configure
make
cd ${pre}
if [ ! -f ./configure ]; then
	./autogen.sh
fi
CFLAGS="$RPM_OPT_FLAGS" LIB="%{_lib}" ./configure \
	--enable-shared \
	--enable-static \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir}
cd nDPI ; ./configure ; make ; cd ..
# fix nasty recordcc-switches: File not found 
for file in $(find . -type f -name Makefile) ; do
 sed -i s@" recordcc-switches "@" -grecord-gcc-switches "@g ${file}
done
%__make

%install
gunzip GeoLiteCity.dat.gz
gunzip GeoIPASNum.dat.gz
gunzip GeoIPASNumv6.dat.gz
%__make DESTDIR=%{buildroot} install
%__install -d %{buildroot}%{_prefix}/lib/nprobe
%__install -d %{buildroot}%{_prefix}/lib/nprobe/plugins
cp GeoLiteCity.dat %{buildroot}%{_prefix}/lib/nprobe/
cp GeoIPASNum.dat %{buildroot}%{_prefix}/lib/nprobe/
cp GeoIPASNumv6.dat %{buildroot}%{_prefix}/lib/nprobe/
find %{buildroot}%{_prefix}/lib/nprobe/plugins -type l -exec rm {} \;
%__install -D -m755 %{S:6} %{buildroot}%{_sysconfdir}/init.d/%{name}
%if 0%{?suse_version}
%__install -D -m644 %{S:7} %{buildroot}/var/adm/fillup-templates/sysconfig.%{name}
%else
%__install -D -m644 %{S:7} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%endif
%__install -d -m755 %{buildroot}%{_sbindir}
ln -sf ../../etc/init.d/nprobe %{buildroot}%{_sbindir}/rcnprobe

# drop .la files
# *** Warning: Linking the shared library libdbPlugin.la against the                                                                                                                                                                                                    
# *** static library /usr/src/packages/BUILD/nprobe_6.9.11_120912_svn2881_proplugins/../PF_RING/userland/libpcap/libpcap.a is not portable!                                                                                                                             
# *** Warning: Linking the shared library libdbPlugin.la against the                                                                                                                                                                                                    
# *** static library /usr/src/packages/BUILD/nprobe_6.9.11_120912_svn2881_proplugins/../PF_RING/userland/lib/libpfring.a is not portable!                                                                                                                               
# *** Warning: Linking the shared library libdbPlugin.la against the                                                                                                                                                                                                    
# *** static library /usr/src/packages/BUILD/nprobe_6.9.11_120912_svn2881_proplugins/nDPI/src/lib/.libs/libndpi.a is not portable!
find %{buildroot} -iname \*.la -exec rm {} \;

%clean
rm -rf %{buildroot}

%post
%if 0%{?suse_version}
%fillup_and_insserv
%else
chkconfig --add %{name} || :
%endif

%postun
%if 0%{?suse_version}
%restart_on_update nprobe
%insserv_cleanup
%else
if [ "$1" == "1" ] ; then
# upgrade
service %{name} restart || :
fi
if [ "$1" == "0" ] ; then
# uninstall
chkconfig --del %{name} || :
fi
%endif

%preun
%if 0%{?suse_version}
%stop_on_removal nprobe
%else
service %{name} stop || :
%endif

%files
%defattr(-,root,root)
%doc UsersGuide.pdf README
%{_sbindir}/rcnprobe
%{_bindir}/nprobe
%dir %{_prefix}/lib/nprobe
%dir %{_prefix}/lib/nprobe/plugins
%{_prefix}/lib/nprobe/GeoIPASNum.dat
%{_prefix}/lib/nprobe/GeoIPASNumv6.dat
%{_prefix}/lib/nprobe/GeoLiteCity.dat
%{_prefix}/lib/nprobe/plugins/libdbPlugin-%{version}.%{sodate}.so
#%{_prefix}/lib/nprobe/plugins/libdbPlugin.la
%{_prefix}/lib/nprobe/plugins/libbgpPlugin-%{version}.%{sodate}.so
#%{_prefix}/lib/nprobe/plugins/libbgpPlugin.la
%{_libdir}/libnprobe-%{version}.%{sodate}.so
#%{_libdir}/libnprobe.la
%{_libdir}/libnprobe.so
%{_sysconfdir}/init.d/%{name}
%if 0%{?suse_version}
/var/adm/fillup-templates/sysconfig.%{name}
%else
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%endif

%files devel
%defattr(-,root,root)
%{_libdir}/libnprobe.a
%if 0%{?sles_version} != 11 && 0%{?suse_version} < 1110 || 0%{?centos_version} > 0 && 0%{?centos_version} < 6 || 0%{?rhel_version} > 0 && 0%{?rhel_version} < 600 || 0%{?sl_version} > 0 && 0%{?sl_version} < 600
%{_prefix}/lib/nprobe/plugins/libdbPlugin.a
%{_prefix}/lib/nprobe/plugins/libbgpPlugin.a
%endif

%changelog
* Tue May 26 2015 cs@linux-administrator.com
- add nprobe-ifindex.patch
- add config flag NPROBE_SENDER_OPTS
* Wed Jul 30 2014 cs@linux-administrator.com
- update init scripts with collector mode functionality
* Tue Jul 29 2014 cs@linux-administrator.com
- added redhat specific init script
- update suse init script
* Wed Jul 23 2014 cs@linux-administrator.com
- update to release 6.16.140620_svn4217
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Fri Mar 21 2014 cs@linux-administrator.com
- update to release 6.16.140307_svn4002
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Mon Feb 10 2014 cs@linux-administrator.com
- update to release 6.15.140110_svn3828
- update PF_RING to 5.6.2
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu Nov 14 2013 cs@linux-administrator.com
- update to release 6.15.131024_svn3789
* Thu Nov 14 2013 cs@linux-administrator.com
- update to release 6.15.131104_svn3786
* Mon Nov  4 2013 cs@linux-administrator.com
- update to release 6.14.131006_svn3758
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Fri Oct  4 2013 cs@linux-administrator.com
- build with zeromq on RHEL 6, CentOS 6, openSUSE and SLES
* Tue Sep 10 2013 cs@linux-administrator.com
- update init script
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP City data
* Tue Aug 27 2013 cs@linux-administrator.com
- update init script to allow running with multiple interfaces
* Sat Aug  3 2013 cs@linux-administrator.com
- update to release 6.13.130718_svn3543
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu Jul  4 2013 cs@linux-administrator.com
- update to release 6.13.130602_svn3505
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Sun Jun  9 2013 cs@linux-administrator.com
- update to release 6.13.130602_svn3472
- update nDPI to current svn
- update PF_RING to 5.6.0
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu Apr  4 2013 cs@linux-administrator.com
- update to release 6.12.130327_svn3352
- update nDPI to current svn
- update PF_RING to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu Mar 28 2013 cs@linux-administrator.com
- update to release 6.12.130315_svn3294
- update nDPI to current svn
- update PF_RING to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Mon Mar 11 2013 cs@linux-administrator.com
- update to release 6.11.130301_svn3231
- update nDPI to current svn
- update PF_RING to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu Feb 21 2013 cs@linux-administrator.com
- update to release 6.11
- update nDPI to current svn
- update PF_RING to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Mon Jan 21 2013 cs@linux-administrator.com
- downgrade to release 6.9.12 again (still unstable)
* Mon Jan 21 2013 cs@linux-administrator.com
- update to release 6.9.13_012013_svn3072
* Sun Jan 20 2013 cs@linux-administrator.com
- downgrade to release 6.9.12 (bug in 6.9.13 crashes nprobe)
* Sat Jan 19 2013 cs@linux-administrator.com
- update to release 6.9.13
- update nDPI to current svn
- update PF_RING to 5.5.2 final
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Wed Jan  2 2013 cs@linux-administrator.com
- update to release 6.9.12
- update nDPI to current svn
- update PF_RING to 5.5.2 svn (rev5883)
* Tue Dec 18 2012 cs@linux-administrator.com
- added PF_RING 5.5.1 at compile time (including libpcap)
* Mon Dec 17 2012 cs@linux-administrator.com
- update to release 6.9.11
- update nDPI to current svn
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Tue Oct  9 2012 cs@linux-administrator.com
- update to release 6.9.9
- update nDPI to current svn
* Wed Oct  3 2012 cs@linux-administrator.com
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
* Thu May 24 2012 cs@linux-administrator.com
- update to release 6.9.5
- update GeoIP ASnum data
- update GeoIP ASnum v6 data
- update GeoIP City data
- update nDPI to current svn
* Sun Mar  4 2012 cs@linux-administrator.com
- update to release 6.9.2
- update GeoIP ASnum data
- added GeoIP ASnum v6 data
- update nDPI to current svn
* Thu Feb  9 2012 cs@linux-administrator.com
- update to release 6.9.1
- update GeoIP data files
- replace opendpi-ntop with nDPI
* Tue Jan 24 2012 cs@linux-administrator.com
- update to release 6.7.3
- update GeoIP data files
* Tue Nov 22 2011 cs@linux-administrator.com
- update to release 6.7.0
- update GeoIP data files
* Mon Sep 12 2011 cs@linux-administrator.com
- Update to release 6.6.3
- Update GeoIP data files
* Mon Aug 15 2011 cs@linux-administrator.com
- update GeoIP data files
